#ifndef _alloc_
#define _alloc_

#include "mlvalues.h"

#define alloc_tuple(len)  tuple_alloc(len)
#define copy_double(d)  alloc_float(d)

static inline value alloc(register mlsize_t len, register tag_t tag) 
{ register value res=block_alloc(len+1);

  TAG(res)=MLINT(tag);
  return res;
}

static inline value copy_string(char *s)
{ return alloc_string(strlen(s),s);
}

extern value copy_string_array(char **);
extern value alloc_array(value (*funct)(char*), char ** array);
extern int convert_flag_list(value, int *);

#endif /* _alloc_ */
